Imports System.IO
Imports System.Xml
Imports System.Net
Imports System.Net.Http
Imports System.Xml.Serialization

Partial Class VB
    Inherits System.Web.UI.Page
    Protected Sub Page_Load(ByVal sender As Object, ByVal e As EventArgs) Handles Me.Load
        If Not Me.IsPostBack Then
            If Not Me.IsPostBack Then
                'Setting TLS 1.2 protocol.
                ServicePointManager.Expect100Continue = True
                ServicePointManager.SecurityProtocol = SecurityProtocolType.Tls12
                Dim client As HttpClient = New HttpClient()
                Dim response As HttpResponseMessage = client.GetAsync("https://asp-umbraco.azurewebsites.net/rss/content").Result

                If response.IsSuccessStatusCode Then
                    Using stream As StringReader = New StringReader(response.Content.ReadAsStringAsync().Result)
                        Using reader As XmlReader = XmlReader.Create(stream)
                            Dim serializer As XmlSerializer = New XmlSerializer(GetType(Rss))
                            Dim rss As Rss = CType(serializer.Deserialize(reader), Rss)
                            rssRepeater.DataSource = rss.Channel.Items
                            rssRepeater.DataBind()
                        End Using
                    End Using
                End If
            End If
        End If
    End Sub

    <XmlType("rss")>
    Public Class Rss
        <XmlElement("channel")>
        Public Property Channel As Channel
    End Class

    <XmlType("channel")>
    Public Class Channel
        <XmlElement("item")>
        Public Property Items As List(Of Item)
    End Class

    Public Class Item
        <XmlElement("title")>
        Public Property Title As String

        <XmlElement("description")>
        Public Property Description As String

        <XmlElement("link")>
        Public Property Link As String

        <XmlElement("pubDate")>
        Public Property PublishedDate As String
    End Class
End Class
